clear all;clc;
a=0.4;w=4;

%Uncomment for Iso
%  nm=0;

% Uncomment for L1
nm=4;marray=zeros(nm,3);
marray(1,1)=1/sqrt(3);marray(1,2)=0;marray(1,3)=sqrt(2)/sqrt(3);
marray(2,1)=-1/sqrt(3);marray(2,2)=0;marray(2,3)=sqrt(2)/sqrt(3);
marray(3,1)=1/sqrt(3);marray(3,2)=0;marray(3,3)=-sqrt(2)/sqrt(3);
marray(4,1)=-1/sqrt(3);marray(4,2)=0;marray(4,3)=-sqrt(2)/sqrt(3);

%  Uncomment for L1
% length = sqrt(1^2+2^2);
%  nm=4;marray=zeros(nm,3);
% marray(1,1)=1/length;marray(1,2)=0;marray(1,3)=2/length;
% marray(2,1)=-1/length;marray(2,2)=0;marray(2,3)=2/length;
% marray(3,1)=1/length;marray(3,2)=0;marray(3,3)=-2/length;
% marray(4,1)=-1/length;marray(4,2)=0;marray(4,3)=-2/length;
% marray(5,1)=0;marray(5,2)=1;marray(5,3)=0;
% marray(6,1)=0;marray(6,2)=-1;marray(6,3)=0;
% % 
% % Uncomment for L2
% nm=1;marray=zeros(nm,3);
% marray(1,1)=0;marray(1,2)=0;marray(1,3)=1;
% marray(2,1)=0;marray(2,2)=0;marray(2,3)=-1;


% Uncomment for box
% nm=6;marray=zeros(nm,3);
% marray(1,1)=1;marray(1,2)=0;marray(1,3)=0;
% marray(2,1)=-1;marray(2,2)=0;marray(2,3)=0;
% marray(3,1)=0;marray(3,2)=1;marray(3,3)=0;
% marray(4,1)=0;marray(4,2)=-1;marray(4,3)=0; 
% marray(5,1)=0;marray(5,2)=0;marray(5,3)=1; 
% marray(6,1)=0;marray(6,2)=0;marray(6,3)=-1;

% Uncomment for diamond
% nm=8; marray=zeros(nm,3);
% marray(1,1)=1;marray(1,2)=1;marray(1,3)=1;
% marray(8,1)=-1;marray(8,2)=-1;marray(8,3)=-1;
% 
% marray(2,1)=-1;marray(2,2)=1;marray(2,3)=1;
% marray(3,1)=1;marray(3,2)=-1;marray(3,3)=-1;
% 
% marray(4,1)=-1;marray(4,2)=-1;marray(4,3)=1;
% marray(5,1)=1;marray(5,2)=1;marray(5,3)=-1;
% 
% marray(6,1)=-1;marray(6,2)=1;marray(6,3)=-1;
% marray(7,1)=1;marray(7,2)=-1;marray(7,3)=1;

% Uncomment for pyramid
% nm=6;marray=zeros(nm,3);
% marray(1,1)=0;marray(1,2)=1;marray(1,3)=0;
% marray(2,1)=-sqrt(3)/2;marray(2,2)=-1/2;marray(2,3)=0;
% marray(3,1)=sqrt(3)/2;marray(3,2)=-1/2;marray(3,3)=0;
% marray(4,1)=0;marray(4,2)=0;marray(4,3)=-1;
% marray(1,1)=0;marray(1,2)=1/sqrt(1.5);marray(1,3)=sqrt(2)/2 /sqrt(1.5);
% marray(2,1)=-sqrt(3)/2/sqrt(1.5);marray(2,2)=-1/2/sqrt(1.5);marray(2,3)=sqrt(2)/2/sqrt(1.5);
% marray(3,1)=sqrt(3)/2/sqrt(1.5);marray(3,2)=-1/2/sqrt(1.5);marray(3,3)=sqrt(2)/2/sqrt(1.5);

% marray(4,2)=0;marray(4,1)=1/sqrt(1.5);marray(4,3)=-sqrt(2)/2 /sqrt(1.5);
% marray(5,2)=-sqrt(3)/2/sqrt(2);marray(5,1)=-1/2/sqrt(2);marray(5,3)=-sqrt(2)/2/sqrt(1.5);
% marray(6,2)=sqrt(3)/2/sqrt(2);marray(6,1)=-1/2/sqrt(2);marray(6,3)=-sqrt(2)/2/sqrt(1.5);
% marray(4,1)=-sqrt(3)/2/sqrt(1.5);marray(4,2)=1/2/sqrt(1.5);marray(4,3)=-sqrt(2)/2/sqrt(1.5);
% marray(5,1)=0;marray(5,2)=-1/sqrt(1.5);marray(5,3)=-sqrt(2)/2/sqrt(1.5);
% marray(6,1)=sqrt(3)/2/sqrt(1.5);marray(6,2)=1/2/sqrt(1.5);marray(6,3)=-sqrt(2)/2/sqrt(1.5);


for steps = 4
    figure(steps)
    N = 50;
    thetavec = linspace(0,pi,N);
    phivec = linspace(0,2*pi,2*N);
    [th, ph] = meshgrid(thetavec,phivec)
    gamma_dir = zeros(2*N,N);
    for it1 = 1:N
        for it2 =1:2*N
             n = [sin(thetavec(it1))*cos(phivec(it2)),sin(thetavec(it1))*sin(phivec(it2)),cos(thetavec(it1))];
             gamma_temp=0;
             for mnumber=1:nm
                 m=[marray(mnumber,1),marray(mnumber,2),marray(mnumber,3)];
                 m=m/norm(m);
                 if n(1)*m(1)+n(2)*m(2)+n(3)*m(3)>0
                     gamma_temp=gamma_temp+a*(n(1)*m(1)+n(2)*m(2)+n(3)*m(3))^w;
                 end
             end
             gamma_dir(it2,it1)=1-gamma_temp;
        end
    end
       
    x = gamma_dir.*sin(th).*cos(ph);
    y = gamma_dir.*sin(th).*sin(ph);
    z = gamma_dir.*cos(th);    
   
    figure(steps);
    surf(x,y,z,gamma_dir);
%     axis equal
    light; lightangle(260,-45) % add 2 lights
    lightangle(10,45)
    lighting gouraud % preferred lighting for a curved surface
    colormap(inferno())
    axis vis3d
    xlabel('e_1');ylabel('e_2');zlabel('e_3');
end
xlim([-1 1]);
ylim([-1 1]);
zlim([-1 1]);
