clear all;clc;
close all

filenames={'Cmat_sharp.mat','Cmat_Twisted.mat'}
c = {'g','r','k','b'};
it = 1;
for file = filenames
   
load(file{1});
lambda = 1;
mu = 1;
Au=[2*mu+lambda,lambda,lambda,0,0,0;lambda,2*mu+lambda,lambda,0,0,0;lambda,lambda,2*mu+lambda,0,0,0;0,0,0,mu,0,0;0,0,0,0,mu,0;0,0,0,0,0,mu];
nn = [1 1 1];


N = 1000;
thetavec = linspace(0,pi/2,N);



C_Voigt = C;

C_Voigt_new = zeros(6,6);

%% Use B matrix
for i = 1:3
    for j = 1:3
        for k = 1:3
            for l = 1:3
                p = i *double(eq(i,j))+ (1-double(eq(i,j)))*(9-i-j);
                q = k *double(eq(k,l))+ (1-double(eq(k,l)))*(9-k-l);
                C_Voigt_new(p,q)=C_Voigt_new(p,q)+C_Voigt(p,q);
            end
        end
    end
end

S_Voigt_new = inv(C_Voigt_new);

E_dir = 0;
nu_dir = 0;
for it1 = 1:N
    
    compliance =0;
    nu_term = 0;
    d = [sin(thetavec(it1)),0,cos(thetavec(it1))];
    nn = [sin(thetavec(it1)+pi/2),0,cos(thetavec(it1)+pi/2)];
%     nn = [-1,0,0];
    for i = 1:3
        for j = 1:3
            for k = 1:3
                for l = 1:3
                    p = i *double(eq(i,j))+ (1-double(eq(i,j)))*(9-i-j);
                    q = k *double(eq(k,l))+ (1-double(eq(k,l)))*(9-k-l);
                    compliance = compliance+d(i)*d(j)*d(k)*d(l)*S_Voigt_new(p,q);
                    nu_term = nu_term+d(i)*d(j)*nn(k)*nn(l)*S_Voigt_new(p,q);
                end
            end
        end
    end
    E_dir(it1) = 1/compliance;
    nu_dir(it1)= -nu_term/compliance;
end

figure(1);
plot(nu_dir.*cos(thetavec),nu_dir.*sin(thetavec),c{it})
hold on;
plot(-nu_dir.*cos(thetavec),nu_dir.*sin(thetavec),c{it})
plot(-nu_dir.*cos(thetavec),-nu_dir.*sin(thetavec),c{it})
plot(nu_dir.*cos(thetavec),-nu_dir.*sin(thetavec),c{it})
it = it+1;
end
xlim([-0.4 0.4])
ylim([-0.4 0.4])
% xlabel('d_1');
% ylabel('d_3');
hold off;
axis equal;
ax = gca;
centeraxes(ax);
% x = E_dir.*sin(th).*cos(ph);
% y = E_dir.*sin(th).*sin(ph);
% z = E_dir.*cos(th);
% 
% x_nu = nu_dir.*sin(th).*cos(ph);
% y_nu = nu_dir.*sin(th).*sin(ph);
% z_nu = nu_dir.*cos(th);


% figure(15);
% surf(x,y,z,E_dir);
% axis equal
% light; lightangle(260,-45) % add 2 lights
% lightangle(60,-45)
% lightangle(10,45)
% lighting gouraud % preferred lighting for a curved surface
% colormap(viridis())
% axis vis3d
% xlabel('e_1');ylabel('e_2');zlabel('e_3');
% 
% figure(16);
% surf(x_nu,y_nu,z_nu,nu_dir);
% axis equal
% light; lightangle(260,-45) % add 2 lights
% lightangle(60,-45)
% lightangle(10,45)
% lighting gouraud % preferred lighting for a curved surface
% colormap(viridis())
% axis vis3d
% xlabel('e_1');ylabel('e_2');zlabel('e_3');
